/*******************************************************************************

Author : Mauro Laurenti
Version : 1.1
Created on Date : 23/9/2015
Last update     : 30/4/2016

CopyRight 2006-2016 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

*******************************************************************************/


#include "UART_test.h"

unsigned char UART_test (void) {

    // For validating this test you have to set 
    //a termninal to 19200b/s, 8 bit format, 1 bit stop, no parity, no ACK
    LCD_clear ();
	LCD_home ();
    
    LCD_write_message ("UART : Terminal");
    LCD_goto_line(2);
    LCD_write_message ("19200,8 bit");       
	UART1_open (UART_BAUDRATE_19200);
    UART1_write_message ("Hello World");
	delay_ms (3000);
    
    return (0);

}


unsigned char RS485_test (void) {
    
    unsigned char write_data = 0x55;
	unsigned char read_data = 0;

    TRISD = 0b11000000;
    
   
    // Send one byte
	UART2_open (UART_BAUDRATE_9600);
	
    //Enable RS485 TX buffer
    LATDbits.LATD5 = 0x01;
    
    //Enable RS485 RX buffer
    LATDbits.LATD2 = 0x00;
    
    UART2_write_byte(write_data);
    delay_ms (200);
    read_data = UART2_read_byte();
	
	LCD_clear ();
	LCD_home ();

	if (read_data == write_data) {
		
		LCD_write_message ("UART_2 : PASS");
		delay_ms (1500);
		return (0);

	} else {

		LCD_write_message ("UART_2 : FAIL");
		delay_ms (1500);
		return (1);
	}
    
}

