/*******************************************************************************

Author : Mauro Laurenti
Version : 1.1
Created on Date : 23/9/2015
Last update     : 30/4/2016

CopyRight 2006-2016 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

*******************************************************************************/


#include "analog_test.h"

//***********************************************************
//
//***********************************************************

void analog_trimmer_test (void) {

	//first reading reference
	unsigned int reference_value = 0;

	// data read
	unsigned int read = 0;
	signed int delta_read = 0;

    LCD_clear ();
    LCD_write_message ("ANALOG :");
    
    reference_value = ADC_read_channel(ADC_CH1);
	
	while (1) {

		read = ADC_read_channel(ADC_CH1);

		delta_read = reference_value - read;

		if ((delta_read > DELTA_POS)||(delta_read < DELTA_NEG) ) {
		
			LCD_clear ();
			LCD_write_message ("ANALOG : PASS");
			delay_ms (1500);
			break;
		} 
	}	
}


//***********************************************************
//
//***********************************************************

void analog_light_test (void) {

	//first reading reference
	unsigned int reference_value = 0;

	// data read
	unsigned int read = 0;
	signed int delta_read = 0;

	LCD_clear ();
	LCD_write_message ("LIGHT :");
	
    // read the first value and use it as reference
	reference_value = ADC_read_channel(ADC_CH0);	

	while (1) {

		read = ADC_read_channel(ADC_CH0);

		delta_read = reference_value - read;

		if ((delta_read > DELTA_LIGTH_POS)||(delta_read < DELTA_LIGTH_NEG) ) {
		
			LCD_clear ();
			LCD_write_message ("LIGHT : PASS");
			delay_ms (1500);
			break;
		} 
	}	
}


//***********************************************************
//
//***********************************************************

void analog_temp_test (void) {

	//used to compute the avarage
	long unsigned int sum;

    unsigned int i ;

	// Data read
	unsigned int read = 0;

	// reference value
	signed int reference_value = 0;

	LCD_clear ();
	LCD_write_message ("TEMP :    ");
	LCD_write_char (223);
	LCD_write_char ('C');
	LCD_shift_cursor (LCD_LEFT,5);

	// read once as reference
	sum = 0;

	// Read 64 values before avaraging
	for (i =0; i<64; i++){
		read = ADC_read_channel(ADC_CH5);
		// summ the value
		sum = sum + read;
	}
	
	// 6 shift for avaraging
	sum = sum >> 6;
	// 1 shift to get temperature in degree
	sum = sum >> 1;

	reference_value = sum;

	while (1) {
		sum = 0;
        
		// Read 64 values before avaraging
		for (i =0; i<64; i++){		
			read = ADC_read_channel(ADC_CH5);			
			sum = sum + read;
		}
			
		// 6 shift for avaraging
        sum = sum >> 6;
        // 1 shift to get temperature in degree
        sum = sum >> 1;

		LCD_write_integer (sum,2, LCD_ZERO_CLEANING_ON);
		LCD_shift_cursor (LCD_LEFT,2);
        
        delay_ms(1000);

		if ((sum - reference_value) > 1) {
			LCD_clear ();
			LCD_write_message ("TEMP : PASS");
			delay_ms (1500);
			break;
		}
	}
}

